var DmarcianAPI = function ($, params) {
    this.$ = $;
    this.ajaxUrl = params.ajaxUrl;
    this.nonce = params.nonce;
    this.nonceKey = params.nonceKey;
};

DmarcianAPI.prototype = {
    constructor: DmarcianAPI,

    post: function (data, callback) {
        // automatically add the nonce to each request
        data[this.nonceKey] = this.nonce;

        // call an empty callback if none is provided
        if (typeof callback == 'undefined') {
            callback = function () {};
        }

        // post data
        this.$.post(this.ajaxUrl, data, function (response) {
            callback(response, 200);
        }).fail(function (xhr) {
            callback({}, xhr.status);
        });
    },

    checkDMARC: function (domain, callback) {
        this.post({
            action: 'dmarcian_admin_check_dmarc',
            domain: domain
        }, callback);
    },

    checkDKIM: function (domain, selector, callback) {
        this.post({
            action: 'dmarcian_admin_check_dkim',
            domain: domain,
            selector: selector
        }, callback);
    },

    checkSPF: function (domain, callback) {
        this.post({
            action: 'dmarcian_admin_check_spf',
            domain: domain
        }, callback);
    },

    deleteDKIM: function (domain, selector, callback) {
        this.post({
            action: 'dmarcian_admin_delete_dkim',
            domain: domain,
            selector: selector
        }, callback);
    },

    refreshCache: function (callback) {
        this.post({
            action: 'dmarcian_admin_refresh_cache'
        }, callback);
    },

    refreshCacheProgress: function (callback) {
        this.post({
            action: 'dmarcian_admin_refresh_cache_progress'
        }, callback);
    },

    getGlobalState: function (callback) {
        this.post({
            action: 'dmarcian_admin_get_global_state'
        }, callback);
    }
};

// expose the API to other scripts to use
var dmarcianAPI = new DmarcianAPI(jQuery, dmarcianAPIParams);