<?php

/**
 * Class Dmarcian_Singleton helps implementing the singleton pattern
 * across various classes.
 */
class Dmarcian_Singleton
{
    /**
     * @var array Holds the created singleton instances.
     */
    protected static $instances = array();

    /**
     * @param array $params Pass parameters to the constructed singleton.
     * @return Dmarcian_Singleton
     */
    public static function get_instance( $params = array() )
    {
        $key = static::class;
        if ( ! array_key_exists( $key, self::$instances ) ) {
            self::$instances[$key] = new static( $params );
        }

        return self::$instances[$key];
    }
}